package com.plannaplan.services;

import java.util.UUID;

import com.plannaplan.abstracts.EventWatcher;
import com.plannaplan.entities.User;
import com.plannaplan.exceptions.UserNotFoundException;
import com.plannaplan.repositories.UserRepository;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class UserService extends EventWatcher {
    @Autowired
    private UserRepository repo;

    public UserService() {
        super();
    }

    public String login(String authority) throws UserNotFoundException {
        User user = this.repo.getByAuthority(authority.replace("\n", "").trim());
        if (user == null) {
            throw new UserNotFoundException("Can not find user with given authority");
        }
        String token = UUID.randomUUID().toString();
        user.setToken(token);
        this.repo.save(user);
        return token;
    }

    public void save(User user) {
        this.repo.save(user);
    }

    public User getUserByEmail(String email) {
        return this.repo.getByAuthority(email.replace("\n", "").trim());
    }

}